"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ObservedCertificate = void 0;
class ObservedCertificate {
    timestamp;
    id;
    _peerConnection;
    appData;
    _visited = false;
    fingerprint;
    fingerprintAlgorithm;
    base64Certificate;
    issuerCertificateId;
    attachments;
    constructor(timestamp, id, _peerConnection) {
        this.timestamp = timestamp;
        this.id = id;
        this._peerConnection = _peerConnection;
    }
    get visited() {
        const visited = this._visited;
        this._visited = false;
        return visited;
    }
    getPeerConnection() {
        return this._peerConnection;
    }
    update(stats) {
        this._visited = true;
        this.timestamp = stats.timestamp;
        this.fingerprint = stats.fingerprint;
        this.fingerprintAlgorithm = stats.fingerprintAlgorithm;
        this.base64Certificate = stats.base64Certificate;
        this.issuerCertificateId = stats.issuerCertificateId;
        this.attachments = stats.attachments;
    }
}
exports.ObservedCertificate = ObservedCertificate;
