import { ObservedCertificate } from './ObservedCertificate';
import { ObservedClient, ObservedClientEvents } from './ObservedClient';
import { ObservedCodec } from './ObservedCodec';
import { ObservedDataChannel } from './ObservedDataChannel';
import { ObservedIceCandidate } from './ObservedIceCandidate';
import { ObservedIceCandidatePair } from './ObservedIceCandidatePair';
import { ObservedIceTransport } from './ObservedIceTransport';
import { ObservedInboundRtp } from './ObservedInboundRtp';
import { ObservedInboundTrack } from './ObservedInboundTrack';
import { ObservedMediaPlayout } from './ObservedMediaPlayout';
import { ObservedMediaSource } from './ObservedMediaSource';
import { ObservedOutboundRtp } from './ObservedOutboundRtp';
import { ObservedOutboundTrack } from './ObservedOutboundTrack';
import { ObservedPeerConnection } from './ObservedPeerConnection';
import { ClientIssue, ClientMetaData, ExtensionStat } from './schema/ClientSample';
export declare class ObservedClientEventMonitor<AppContext, ClientAppData extends Record<string, unknown> = Record<string, unknown>> {
    readonly observedClient: ObservedClient<ClientAppData>;
    readonly context: AppContext;
    constructor(observedClient: ObservedClient<ClientAppData>, context: AppContext);
    onClientUpdated?: (client: ObservedClient, event: ObservedClientEvents['update'][0], ctx: AppContext) => void;
    private _onClientUpdated;
    onClientClosed?: (client: ObservedClient, ctx: AppContext) => void;
    private _onClientClosed;
    onPeerConnectionAdded?: (peerConnection: ObservedPeerConnection, ctx: AppContext) => void;
    private _onPeerConnconnectionAdded;
    onPeerConnectionRemoved?: (peerConnection: ObservedPeerConnection, ctx: AppContext) => void;
    private _onPeerConnectionRemoved;
    onCertificateAdded?: (certificate: ObservedCertificate, ctx: AppContext) => void;
    private _onCertificateAdded;
    onCertificateRemoved?: (certificate: ObservedCertificate, ctx: AppContext) => void;
    private _onCertificateRemoved;
    onInboundTrackAdded?: (inboundTrack: ObservedInboundTrack, ctx: AppContext) => void;
    private _onInboundTrackAdded;
    onInboundTrackRemoved?: (inboundTrack: ObservedInboundTrack, ctx: AppContext) => void;
    private _onInboundTrackRemoved;
    onOutboundTrackAdded?: (outboundTrack: ObservedOutboundTrack, ctx: AppContext) => void;
    private _onOutboundTrackAdded;
    onOutboundTrackRemoved?: (outboundTrack: ObservedOutboundTrack, ctx: AppContext) => void;
    private _onOutboundTrackRemoved;
    onInboundRtpAdded?: (inboundRtp: ObservedInboundRtp, ctx: AppContext) => void;
    private _onInboundRtpAdded;
    onInboundRtpRemoved?: (inboundRtp: ObservedInboundRtp, ctx: AppContext) => void;
    private _onInboundRtpRemoved;
    onOutboundRtpAdded?: (outboundRtp: ObservedOutboundRtp, ctx: AppContext) => void;
    private _onOutboundRtpAdded;
    onOutboundRtpRemoved?: (outboundRtp: ObservedOutboundRtp, ctx: AppContext) => void;
    private _onOutboundRtpRemoved;
    onDataChannelAdded?: (dataChannel: ObservedDataChannel, ctx: AppContext) => void;
    private _onDataChannelAdded;
    onDataChannelRemoved?: (dataChannel: ObservedDataChannel, ctx: AppContext) => void;
    private _onDataChannelRemoved;
    onAddedIceTransport?: (iceTransport: ObservedIceTransport, ctx: AppContext) => void;
    private _onAddedIceTransport;
    onRemovedIceTransport?: (iceTransport: ObservedIceTransport, ctx: AppContext) => void;
    private _onRemovedIceTransport;
    onIceCandidateAdded?: (iceCandidate: ObservedIceCandidate, ctx: AppContext) => void;
    private _onIceCandidateAdded;
    onIceCandidateRemoved?: (iceCandidate: ObservedIceCandidate, ctx: AppContext) => void;
    private _onIceCandidateRemoved;
    onAddedIceCandidatePair?: (candidatePair: ObservedIceCandidatePair, ctx: AppContext) => void;
    private _onAddedIceCandidatePair;
    onRemovedIceCandidatePair?: (candidatePair: ObservedIceCandidatePair, ctx: AppContext) => void;
    private _onRemovedIceCandidatePair;
    onAddedMediaCodec?: (codec: ObservedCodec, ctx: AppContext) => void;
    private _onAddedMediaCodec;
    onRemovedMediaCodec?: (codec: ObservedCodec, ctx: AppContext) => void;
    private _onRemovedMediaCodec;
    onAddedMediaPlayout?: (mediaPlayout: ObservedMediaPlayout, ctx: AppContext) => void;
    private _onAddedMediaPlayout;
    onRemovedMediaPlayout?: (mediaPlayout: ObservedMediaPlayout, ctx: AppContext) => void;
    private _onRemovedMediaPlayout;
    onMediaSourceAdded?: (mediaSource: ObservedMediaSource, ctx: AppContext) => void;
    private _onMediaSourceAdded;
    onMediaSourceRemoved?: (mediaSource: ObservedMediaSource, ctx: AppContext) => void;
    private _onMediaSourceRemoved;
    onClientIssue?: (issue: ClientIssue, ctx: AppContext) => void;
    private _onClientIssue;
    onClientMetadata?: (metadata: ClientMetaData, ctx: AppContext) => void;
    private _onClientMetadata;
    onClientExtensionStats?: (extensionStats: ExtensionStat, ctx: AppContext) => void;
    private _onClientExtensionStats;
    onClientJoined?: (client: ObservedClient, ctx: AppContext) => void;
    private _onClientJoined;
    onClientLeft?: (client: ObservedClient, ctx: AppContext) => void;
    private _onClientLeft;
    onUserMediaError?: (error: string, observedClient: ObservedClient, ctx: AppContext) => void;
    private _onUserMediaError;
    onUsingTurn?: (client: ObservedClient, ctx: AppContext) => void;
    private _onUsingTurn;
}
//# sourceMappingURL=ObservedClientEventMonitor.d.ts.map