import { ObservedPeerConnection } from './ObservedPeerConnection';
import { DataChannelStats } from './schema/ClientSample';
export type ObservedDataChannelState = 'connecting' | 'open' | 'closing' | 'closed';
export declare class ObservedDataChannel implements DataChannelStats {
    timestamp: number;
    id: string;
    private readonly _peerConnection;
    private _visited;
    label?: string | undefined;
    protocol?: string | undefined;
    dataChannelIdentifier?: number | undefined;
    state?: string | undefined;
    messagesSent?: number | undefined;
    bytesSent?: number | undefined;
    messagesReceived?: number | undefined;
    bytesReceived?: number | undefined;
    attachments?: Record<string, unknown> | undefined;
    addedAt?: number | undefined;
    removedAt?: number | undefined;
    deltaBytesSent: number;
    deltaBytesReceived: number;
    deltaMessagesSent: number;
    deltaMessagesReceived: number;
    appData?: Record<string, unknown>;
    constructor(timestamp: number, id: string, _peerConnection: ObservedPeerConnection);
    get visited(): boolean;
    getPeerConnection(): ObservedPeerConnection;
    update(stats: DataChannelStats): void;
}
//# sourceMappingURL=ObservedDataChannel.d.ts.map