import { ObservedPeerConnection } from './ObservedPeerConnection';
import { IceCandidatePairStats } from './schema/ClientSample';
export declare class ObservedIceCandidatePair implements IceCandidatePairStats {
    timestamp: number;
    id: string;
    private readonly _peerConnection;
    private _visited;
    appData?: Record<string, unknown>;
    transportId?: string | undefined;
    localCandidateId?: string | undefined;
    remoteCandidateId?: string | undefined;
    state?: 'new' | 'in-progress' | 'waiting' | 'failed' | 'succeeded' | undefined;
    nominated?: boolean | undefined;
    packetsSent?: number | undefined;
    packetsReceived?: number | undefined;
    bytesSent?: number | undefined;
    bytesReceived?: number | undefined;
    lastPacketSentTimestamp?: number | undefined;
    lastPacketReceivedTimestamp?: number | undefined;
    totalRoundTripTime?: number | undefined;
    currentRoundTripTime?: number | undefined;
    availableOutgoingBitrate?: number | undefined;
    availableIncomingBitrate?: number | undefined;
    requestsReceived?: number | undefined;
    requestsSent?: number | undefined;
    responsesReceived?: number | undefined;
    responsesSent?: number | undefined;
    consentRequestsSent?: number | undefined;
    packetsDiscardedOnSend?: number | undefined;
    bytesDiscardedOnSend?: number | undefined;
    attachments?: Record<string, unknown> | undefined;
    deltaBytesSent: number;
    deltaBytesReceived: number;
    deltaPacketsSent: number;
    deltaPacketsReceived: number;
    constructor(timestamp: number, id: string, _peerConnection: ObservedPeerConnection);
    get visited(): boolean;
    getPeerConnection(): ObservedPeerConnection;
    getIceTransport(): import("./ObservedIceTransport").ObservedIceTransport | undefined;
    getLocalCandidate(): import("./ObservedIceCandidate").ObservedIceCandidate | undefined;
    getRemoteCandidate(): import("./ObservedIceCandidate").ObservedIceCandidate | undefined;
    update(stats: IceCandidatePairStats): void;
    private _convertState;
}
//# sourceMappingURL=ObservedIceCandidatePair.d.ts.map