import { ObservedPeerConnection } from './ObservedPeerConnection';
import { IceTransportStats } from './schema/ClientSample';
export declare class ObservedIceTransport implements IceTransportStats {
    timestamp: number;
    id: string;
    private readonly _peerConnection;
    private _visited;
    appData?: Record<string, unknown>;
    packetsSent?: number | undefined;
    packetsReceived?: number | undefined;
    bytesSent?: number | undefined;
    bytesReceived?: number | undefined;
    iceRole?: string | undefined;
    iceLocalUsernameFragment?: string | undefined;
    dtlsState?: string | undefined;
    iceState?: string | undefined;
    selectedCandidatePairId?: string | undefined;
    localCertificateId?: string | undefined;
    remoteCertificateId?: string | undefined;
    tlsVersion?: string | undefined;
    dtlsCipher?: string | undefined;
    dtlsRole?: string | undefined;
    srtpCipher?: string | undefined;
    selectedCandidatePairChanges?: number | undefined;
    attachments?: Record<string, unknown> | undefined;
    deltaPacketsReceived: number;
    deltaPacketsSent: number;
    deltaBytesReceived: number;
    deltaBytesSent: number;
    constructor(timestamp: number, id: string, _peerConnection: ObservedPeerConnection);
    get visited(): boolean;
    getPeerConnection(): ObservedPeerConnection;
    getSelectedCandidatePair(): import("./ObservedIceCandidatePair").ObservedIceCandidatePair | undefined;
    update(stats: IceTransportStats): void;
}
//# sourceMappingURL=ObservedIceTransport.d.ts.map