import { MediaKind } from './common/types';
import { ObservedPeerConnection } from './ObservedPeerConnection';
import { InboundRtpStats } from './schema/ClientSample';
export declare class ObservedInboundRtp implements InboundRtpStats {
    timestamp: number;
    id: string;
    ssrc: number;
    kind: MediaKind;
    trackIdentifier: string;
    private readonly _peerConnection;
    appData?: Record<string, unknown>;
    private _visited;
    transportId?: string | undefined;
    codecId?: string | undefined;
    packetsReceived?: number | undefined;
    packetsLost?: number | undefined;
    mid?: string | undefined;
    remoteId?: string | undefined;
    framesDecoded?: number | undefined;
    keyFramesDecoded?: number | undefined;
    framesRendered?: number | undefined;
    framesDropped?: number | undefined;
    frameWidth?: number | undefined;
    frameHeight?: number | undefined;
    framesPerSecond?: number | undefined;
    qpSum?: number | undefined;
    totalDecodeTime?: number | undefined;
    totalInterFrameDelay?: number | undefined;
    totalSquaredInterFrameDelay?: number | undefined;
    pauseCount?: number | undefined;
    totalPausesDuration?: number | undefined;
    freezeCount?: number | undefined;
    totalFreezesDuration?: number | undefined;
    lastPacketReceivedTimestamp?: number | undefined;
    headerBytesReceived?: number | undefined;
    packetsDiscarded?: number | undefined;
    fecBytesReceived?: number | undefined;
    fecPacketsReceived?: number | undefined;
    fecPacketsDiscarded?: number | undefined;
    bytesReceived?: number | undefined;
    nackCount?: number | undefined;
    firCount?: number | undefined;
    pliCount?: number | undefined;
    totalProcessingDelay?: number | undefined;
    estimatedPlayoutTimestamp?: number | undefined;
    jitterBufferDelay?: number | undefined;
    jitterBufferTargetDelay?: number | undefined;
    jitterBufferEmittedCount?: number | undefined;
    jitterBufferMinimumDelay?: number | undefined;
    totalSamplesReceived?: number | undefined;
    concealedSamples?: number | undefined;
    silentConcealedSamples?: number | undefined;
    concealmentEvents?: number | undefined;
    insertedSamplesForDeceleration?: number | undefined;
    removedSamplesForAcceleration?: number | undefined;
    audioLevel?: number | undefined;
    totalAudioEnergy?: number | undefined;
    totalSamplesDuration?: number | undefined;
    framesReceived?: number | undefined;
    decoderImplementation?: string | undefined;
    playoutId?: string | undefined;
    powerEfficientDecoder?: boolean | undefined;
    framesAssembledFromMultiplePackets?: number | undefined;
    totalAssemblyTime?: number | undefined;
    retransmittedPacketsReceived?: number | undefined;
    retransmittedBytesReceived?: number | undefined;
    rtxSsrc?: number | undefined;
    fecSsrc?: number | undefined;
    totalCorruptionProbability?: number | undefined;
    totalSquaredCorruptionProbability?: number | undefined;
    corruptionMeasurements?: number | undefined;
    attachments?: Record<string, unknown> | undefined;
    jitter?: number | undefined;
    bitrate: number;
    fractionLost?: number;
    bitPerPixel: number;
    deltaLostPackets: number;
    deltaReceivedPackets: number;
    deltaBytesReceived: number;
    deltaReceivedSamples: number;
    deltaSilentConcealedSamples: number;
    constructor(timestamp: number, id: string, ssrc: number, kind: MediaKind, trackIdentifier: string, _peerConnection: ObservedPeerConnection);
    get visited(): boolean;
    getPeerConnection(): ObservedPeerConnection;
    getRemoteOutboundRtp(): import("./ObservedRemoteOutboundRtp").ObservedRemoteOutboundRtp | undefined;
    getIceTransport(): import("./ObservedIceTransport").ObservedIceTransport | undefined;
    getCodec(): import("./ObservedCodec").ObservedCodec | undefined;
    getMediaPlayout(): import("./ObservedMediaPlayout").ObservedMediaPlayout | undefined;
    getTrack(): import("./ObservedInboundTrack").ObservedInboundTrack | undefined;
    update(stats: InboundRtpStats): void;
}
//# sourceMappingURL=ObservedInboundRtp.d.ts.map