import { CalculatedScore } from './scores/CalculatedScore';
import { MediaKind } from './common/types';
import { InboundTrackSample } from './schema/ClientSample';
import { Detectors } from './detectors/Detectors';
import { ObservedPeerConnection } from './ObservedPeerConnection';
import { ObservedInboundRtp } from './ObservedInboundRtp';
import { ObservedMediaPlayout } from './ObservedMediaPlayout';
export declare class ObservedInboundTrack implements InboundTrackSample {
    timestamp: number;
    readonly id: string;
    readonly kind: MediaKind;
    private readonly _peerConnection;
    private readonly _inboundRtp?;
    private readonly _mediaPlayout?;
    readonly detectors: Detectors;
    readonly calculatedScore: CalculatedScore;
    appData?: Record<string, unknown>;
    private _visited;
    addedAt?: number | undefined;
    removedAt?: number | undefined;
    muted?: boolean;
    attachments?: Record<string, unknown> | undefined;
    constructor(timestamp: number, id: string, kind: MediaKind, _peerConnection: ObservedPeerConnection, _inboundRtp?: ObservedInboundRtp | undefined, _mediaPlayout?: ObservedMediaPlayout | undefined);
    get score(): number | undefined;
    get visited(): boolean;
    getPeerConnection(): ObservedPeerConnection;
    getInboundRtp(): ObservedInboundRtp | undefined;
    getMediaPlayout(): ObservedMediaPlayout | undefined;
    getRemoteOutboundTrack(): import("./ObservedOutboundTrack").ObservedOutboundTrack | undefined;
    update(stats: InboundTrackSample): void;
}
//# sourceMappingURL=ObservedInboundTrack.d.ts.map