import { MediaKind } from './common/types';
import { ObservedPeerConnection } from './ObservedPeerConnection';
import { MediaPlayoutStats } from './schema/ClientSample';
export declare class ObservedMediaPlayout implements MediaPlayoutStats {
    timestamp: number;
    id: string;
    kind: MediaKind;
    private readonly _peerConnection;
    private _visited;
    appData?: Record<string, unknown>;
    synthesizedSamplesDuration?: number | undefined;
    synthesizedSamplesEvents?: number | undefined;
    totalSamplesDuration?: number | undefined;
    totalPlayoutDelay?: number | undefined;
    totalSamplesCount?: number | undefined;
    attachments?: Record<string, unknown> | undefined;
    constructor(timestamp: number, id: string, kind: MediaKind, _peerConnection: ObservedPeerConnection);
    get visited(): boolean;
    getPeerConnection(): ObservedPeerConnection;
    update(stats: MediaPlayoutStats): void;
}
//# sourceMappingURL=ObservedMediaPlayout.d.ts.map