import { MediaKind } from './common/types';
import { ObservedPeerConnection } from './ObservedPeerConnection';
import { MediaSourceStats } from './schema/ClientSample';
export declare class ObservedMediaSource implements MediaSourceStats {
    timestamp: number;
    id: string;
    kind: MediaKind;
    private readonly _peerConnection;
    private _visited;
    appData?: Record<string, unknown>;
    trackIdentifier?: string | undefined;
    audioLevel?: number | undefined;
    totalAudioEnergy?: number | undefined;
    totalSamplesDuration?: number | undefined;
    echoReturnLoss?: number | undefined;
    echoReturnLossEnhancement?: number | undefined;
    width?: number | undefined;
    height?: number | undefined;
    frames?: number | undefined;
    framesPerSecond?: number | undefined;
    attachments?: Record<string, unknown> | undefined;
    constructor(timestamp: number, id: string, kind: MediaKind, _peerConnection: ObservedPeerConnection);
    get visited(): boolean;
    getPeerConnection(): ObservedPeerConnection;
    getTrack(): import("./ObservedOutboundTrack").ObservedOutboundTrack | undefined;
    update(stats: MediaSourceStats): void;
}
//# sourceMappingURL=ObservedMediaSource.d.ts.map