import { MediaKind } from './common/types';
import { ObservedPeerConnection } from './ObservedPeerConnection';
import { OutboundRtpStats, QualityLimitationDurations } from './schema/ClientSample';
export declare class ObservedOutboundRtp implements OutboundRtpStats {
    timestamp: number;
    id: string;
    ssrc: number;
    kind: MediaKind;
    private readonly _peerConnection;
    private _visited;
    appData?: Record<string, unknown>;
    transportId?: string | undefined;
    codecId?: string | undefined;
    packetsSent?: number | undefined;
    bytesSent?: number | undefined;
    mid?: string | undefined;
    mediaSourceId?: string | undefined;
    remoteId?: string | undefined;
    rid?: string | undefined;
    headerBytesSent?: number | undefined;
    retransmittedPacketsSent?: number | undefined;
    retransmittedBytesSent?: number | undefined;
    rtxSsrc?: number | undefined;
    targetBitrate?: number | undefined;
    totalEncodedBytesTarget?: number | undefined;
    frameWidth?: number | undefined;
    frameHeight?: number | undefined;
    framesPerSecond?: number | undefined;
    framesSent?: number | undefined;
    hugeFramesSent?: number | undefined;
    framesEncoded?: number | undefined;
    keyFramesEncoded?: number | undefined;
    qpSum?: number | undefined;
    totalEncodeTime?: number | undefined;
    totalPacketSendDelay?: number | undefined;
    qualityLimitationReason?: string | undefined;
    qualityLimitationResolutionChanges?: number | undefined;
    nackCount?: number | undefined;
    firCount?: number | undefined;
    pliCount?: number | undefined;
    encoderImplementation?: string | undefined;
    powerEfficientEncoder?: boolean | undefined;
    active?: boolean | undefined;
    scalabilityMode?: string | undefined;
    qualityLimitationDurations?: QualityLimitationDurations | undefined;
    attachments?: Record<string, unknown> | undefined;
    bitrate: number;
    payloadBitrate: number;
    packetRate: number;
    bitPerPixel: number;
    deltaPacketsSent: number;
    deltaBytesSent: number;
    constructor(timestamp: number, id: string, ssrc: number, kind: MediaKind, _peerConnection: ObservedPeerConnection);
    get visited(): boolean;
    getPeerConnection(): ObservedPeerConnection;
    getRemoteInboundRtp(): import("./ObservedRemoteInboundRtp").ObservedRemoteInboundRtp | undefined;
    getCodec(): import("./ObservedCodec").ObservedCodec | undefined;
    getMediaSource(): import("./ObservedMediaSource").ObservedMediaSource | undefined;
    getTrack(): import("./ObservedOutboundTrack").ObservedOutboundTrack | undefined;
    update(stats: OutboundRtpStats): void;
}
//# sourceMappingURL=ObservedOutboundRtp.d.ts.map