import { CalculatedScore } from './scores/CalculatedScore';
import { MediaKind } from './common/types';
import { OutboundTrackSample } from './schema/ClientSample';
import { Detectors } from './detectors/Detectors';
import { ObservedPeerConnection } from './ObservedPeerConnection';
import { ObservedOutboundRtp } from './ObservedOutboundRtp';
import { ObservedMediaSource } from './ObservedMediaSource';
export declare class ObservedOutboundTrack implements OutboundTrackSample {
    timestamp: number;
    readonly id: string;
    readonly kind: MediaKind;
    private readonly _peerConnection;
    private readonly _outboundRtps?;
    private readonly _mediaSource?;
    readonly detectors: Detectors;
    private _visited;
    appData?: Record<string, unknown>;
    readonly calculatedScore: CalculatedScore;
    addedAt?: number | undefined;
    removedAt?: number | undefined;
    muted?: boolean;
    attachments?: Record<string, unknown> | undefined;
    constructor(timestamp: number, id: string, kind: MediaKind, _peerConnection: ObservedPeerConnection, _outboundRtps?: ObservedOutboundRtp[] | undefined, _mediaSource?: ObservedMediaSource | undefined);
    get score(): number | undefined;
    get visited(): boolean;
    getPeerConnection(): ObservedPeerConnection;
    getOutboundRtps(): ObservedOutboundRtp[] | undefined;
    getMediaSource(): ObservedMediaSource | undefined;
    getRemoteInboundTracks(): import("./ObservedInboundTrack").ObservedInboundTrack[] | undefined;
    update(stats: OutboundTrackSample): void;
}
//# sourceMappingURL=ObservedOutboundTrack.d.ts.map