import { MediaKind } from './common/types';
import { ObservedPeerConnection } from './ObservedPeerConnection';
import { RemoteInboundRtpStats } from './schema/ClientSample';
export declare class ObservedRemoteInboundRtp implements RemoteInboundRtpStats {
    timestamp: number;
    id: string;
    ssrc: number;
    kind: MediaKind;
    private readonly _peerConnection;
    private _visited;
    appData?: Record<string, unknown>;
    transportId?: string | undefined;
    codecId?: string | undefined;
    packetsReceived?: number | undefined;
    packetsLost?: number | undefined;
    jitter?: number | undefined;
    localId?: string | undefined;
    roundTripTime?: number | undefined;
    totalRoundTripTime?: number | undefined;
    fractionLost?: number | undefined;
    roundTripTimeMeasurements?: number | undefined;
    attachments?: Record<string, unknown> | undefined;
    constructor(timestamp: number, id: string, ssrc: number, kind: MediaKind, _peerConnection: ObservedPeerConnection);
    get visited(): boolean;
    getPeerConnection(): ObservedPeerConnection;
    getOutboundRtp(): import("./ObservedOutboundRtp").ObservedOutboundRtp | undefined;
    getCodec(): import("./ObservedCodec").ObservedCodec | undefined;
    update(stats: RemoteInboundRtpStats): void;
}
//# sourceMappingURL=ObservedRemoteInboundRtp.d.ts.map