import { MediaKind } from './common/types';
import { ObservedPeerConnection } from './ObservedPeerConnection';
import { RemoteOutboundRtpStats } from './schema/ClientSample';
export declare class ObservedRemoteOutboundRtp implements RemoteOutboundRtpStats {
    timestamp: number;
    id: string;
    ssrc: number;
    kind: MediaKind;
    private readonly _peerConnection;
    private _visited;
    appData?: Record<string, unknown>;
    transportId?: string | undefined;
    codecId?: string | undefined;
    packetsSent?: number | undefined;
    bytesSent?: number | undefined;
    localId?: string | undefined;
    remoteTimestamp?: number | undefined;
    reportsSent?: number | undefined;
    roundTripTime?: number | undefined;
    totalRoundTripTime?: number | undefined;
    roundTripTimeMeasurements?: number | undefined;
    attachments?: Record<string, unknown> | undefined;
    constructor(timestamp: number, id: string, ssrc: number, kind: MediaKind, _peerConnection: ObservedPeerConnection);
    get visited(): boolean;
    getPeerConnection(): ObservedPeerConnection;
    getInboundRtp(): import("./ObservedInboundRtp").ObservedInboundRtp | undefined;
    getCodec(): import("./ObservedCodec").ObservedCodec | undefined;
    update(stats: RemoteOutboundRtpStats): void;
}
//# sourceMappingURL=ObservedRemoteOutboundRtp.d.ts.map