export type Middleware<T> = (input: T, next: (nextInput: T) => void) => void;
export interface Processor<T> {
    finalCallback?: Callback<T>;
    process(value: T): void;
    addMiddleware(...middlewares: Middleware<T>[]): Processor<T>;
    removeMiddleware(...middlewares: Middleware<T>[]): Processor<T>;
}
type Callback<T> = (input: T) => void;
export declare class MiddlewareProcessor<T> implements Processor<T> {
    private stack;
    finalCallback?: Callback<T>;
    addMiddleware(...middlewares: Middleware<T>[]): Processor<T>;
    removeMiddleware(...middlewares: Middleware<T>[]): Processor<T>;
    process(value: T): void;
}
export {};
//# sourceMappingURL=Middleware.d.ts.map