"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setObserverLogger = exports.createLogger = void 0;
let mainLogger = new class {
    trace = () => void 0;
    // trace(module: string, ...args: any[]) {
    // 	// eslint-disable-next-line no-console
    // 	console.log(`[TRACE] ${module}`, ...args);
    // }
    debug(module, ...args) {
        // eslint-disable-next-line no-console
        console.log(`[DEBUG] ${module}`, ...args);
    }
    info(module, ...args) {
        // eslint-disable-next-line no-console
        console.info(`[INFO] ${module}`, ...args);
    }
    warn(module, ...args) {
        // eslint-disable-next-line no-console
        console.warn(`[WARN] ${module}`, ...args);
    }
    error(module, ...args) {
        // eslint-disable-next-line no-console
        console.error(`[ERROR] ${module}`, ...args);
    }
}();
function createLogger(moduleName) {
    return new class {
        trace(...args) {
            mainLogger.trace(moduleName, ...args);
        }
        debug(...args) {
            mainLogger.debug(moduleName, ...args);
        }
        info(...args) {
            mainLogger.info(moduleName, ...args);
        }
        warn(...args) {
            mainLogger.warn(moduleName, ...args);
        }
        error(...args) {
            mainLogger.error(moduleName, ...args);
        }
    }();
}
exports.createLogger = createLogger;
function setObserverLogger(logger) {
    mainLogger = logger;
}
exports.setObserverLogger = setObserverLogger;
