"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultCallScoreCalculator = void 0;
class DefaultCallScoreCalculator {
    observedCall;
    constructor(observedCall) {
        this.observedCall = observedCall;
    }
    update() {
        let totalScore = 0;
        let totalWeight = 0;
        for (const client of this.observedCall.observedClients.values()) {
            if (client.score === undefined)
                continue;
            totalScore += client.score * client.calculatedScore.weight;
            totalWeight += client.calculatedScore.weight;
        }
        this.observedCall.calculatedScore.value = totalWeight ? totalScore / totalWeight : undefined;
    }
}
exports.DefaultCallScoreCalculator = DefaultCallScoreCalculator;
