import { ObservedCall } from '../ObservedCall';
import { ObservedCallEventMonitor } from '../ObservedCallEventMonitor';
import { ObservedInboundTrack } from '../ObservedInboundTrack';
import { ObservedOutboundTrack } from '../ObservedOutboundTrack';
import { RemoteTrackResolver } from './RemoteTrackResolver';
export declare class MediasoupRemoteTrackResolver implements RemoteTrackResolver {
    readonly observedCall: ObservedCall;
    readonly eventMonitor: ObservedCallEventMonitor<{}>;
    private _consumerIdToProducerId;
    private _producerIdToOutboundTrack;
    private _consumerIdToInboundTrack;
    private _inboundTrackToConsumerId;
    private _producerIdToConsumerIds;
    private _outboundTrackToProducerId;
    constructor(observedCall: ObservedCall);
    resolveRemoteOutboundTrack(inboundTrack: ObservedInboundTrack): ObservedOutboundTrack | undefined;
    resolveRemoteInboundTracks(outboundTrack: ObservedOutboundTrack): ObservedInboundTrack[] | undefined;
    private _addInboundTrack;
    private _removeInboundTrack;
    private _addOutboundTrack;
    private _removeOutboundTrack;
    private _getInboundTrackAttachments;
    private _getOutboundTrackAttachments;
}
//# sourceMappingURL=MediasoupRemoteTrackResolver.d.ts.map